// Generated by CoffeeScript 2.3.0
var EventEmitter, cush, events, os, path;

EventEmitter = require('events');

path = require('path');

os = require('os');

cush = exports;

cush.config = require('./config');

cush.verbose = process.env.VERBOSE !== '';

// Cache directories
cush.BASE_DIR = path.join(os.homedir(), '.cush');

cush.BUNDLE_DIR = path.join(cush.BASE_DIR, 'bundles');

cush.PACKAGE_DIR = path.join(cush.BASE_DIR, 'packages');

// Global events
events = new EventEmitter;

cush.emit = events.emit.bind(events);

cush.on = events.on.bind(events);

cush.off = function(name, listener) {
  if (name === '*') {
    return events.removeAllListeners();
  } else {
    return events.removeListener(name, listener);
  }
};

// Prevent warnings from going unseen.
cush.on('warning', function() {
  if (events.listenerCount('warning') === 1) {
    console.warn.apply(console, arguments);
  }
});

cush.on('error', function() {
  if (events.listenerCount('error') === 1) {
    console.error.apply(console, arguments);
  }
});
