// Generated by CoffeeScript 2.3.0
var brew, brewed, cush, lazyRequire, mapSources, path, semver, transform;

({lazyRequire, mapSources} = require('../../utils'));

semver = require('semver');

cush = require('cush');

path = require('path');

// Loaded versions
brewed = {};

// TODO: use version present in `node_modules` by default?
brew = async function(pack) {
  var coffee, deps, match, version;
  if (!(deps = pack.data.devDependencies)) {
    return;
  }
  if (!(version = deps['coffeescript'] || deps['coffee-script'])) {
    return;
  }
  // Check if a loaded version fits the bill.
  if (match = semver.maxSatisfying(Object.keys(brewed), version)) {
    return brewed[match];
  }
  // Install the required version.
  coffee = (await lazyRequire('coffeescript', version));
  brewed[coffee.VERSION] = coffee;
  return coffee;
};

transform = async function(file, pack) {
  var compile, filename, res;
  filename = pack.resolve(file);
  if (!(pack.coffee || (pack.coffee = (await brew(pack))))) {
    cush.emit('warning', {
      message: 'Missing "coffeescript" dependency',
      file: filename
    });
    return;
  }
  ({compile} = pack.coffee);
  res = compile(file.content, {
    filename: filename,
    sourceMap: true,
    bare: true
  });
  res.content = res.js;
  res.map = JSON.parse(res.v3SourceMap);
  mapSources(file, res);
  file.ext = '.js';
};

exports['.coffee'] = exports['.coffee.md'] = exports['.litcoffee'] = transform;
